//パネル設定　ここから
var dialog = new Window('dialog','トリムマークとガイド',[0,0,240,280]);//パネル外枠
dialog.titel = dialog.add('panel',[20,15,220,115],'ガイドオフセット');//ガイドオフセット枠
var checkBox1 = dialog.add('checkbox',[35,38,150,55],'ガイド作成');//チェックボックス
dialog.add('statictext',[35,55,130,80],'オフセット値：');
var offSet = dialog.add('edittext',[130,60,170,80],'10');//数値の入力 
dialog.add('statictext',[180,55,260,80],'mm');
dialog.add('statictext',[35,85,115,107],'レイヤー名：');
var layerName1  = dialog.add('edittext',[120,85,200,110],'guides');//レイヤー名の入力

dialog.titel = dialog.add('panel',[20,125,220,210],'トリムマーク');//トリムマーク枠
var checkbox2 = dialog.add('checkbox',[35,150,180,164],'トリムマーク作成');//チェックボックス
dialog.add('statictext',[35,180,220,194],'レイヤー名：');
var layerName2 = dialog.add('edittext',[120,175,200,200],'trimMark');//レイヤー名の入力

var btnOk = dialog.add('button',[20,225,110,250],'OK',{name:'OK'});//OKボタン
var btnCancel = dialog.add('button',[115,225,210,250],'cancel',{name:'cancel'});//CANCELボタン
offSet.active = true;//オフセット値にフォーカス
//パネル設定　ここまで

//パネル初期値ここから
checkBox1.value = true;//オフセットにチェック
checkbox2.value = true;//トリムマークにチェック
//パネル初期値ここまで

//キャンセルボタンの処理ここから
btnCancel.onClick = function(){
    dialog.close();//パネルを閉じる
}
//キャンセルボタンの処理ここまで

//OKボタンの処理ここから
btnOk.onClick = function () {
    dialog.close();//パネルを閉じる
    var docObj = app.activeDocument;
    CoordinateSystem.ARTBOARDCOORDINATESYSTEM;

    //レイヤー作成ここから
    if(checkBox1.value === true){
        var layObj1 = docObj.layers.add();
        layObj1.name = layerName1.text; //.textで文字をテキスト変換
    };
    if(checkbox2.value === true){
        var layObj2 = docObj.layers.add();
        layObj2.name = layerName2.text;
    };
    //レイヤー作成ここまで

    for(var i = 0; i<docObj.artboards.length; i++){//アートボードの数を数えて処理を繰り返す

        //アートボード縦横サイズの計測ここから
        var rect = docObj.artboards[i].artboardRect; //アクティブアートボードを指定
        var left = rect[0];//左
        var top = rect[1];//上
        var right = rect[2];//右
        var bottom = rect[3];//下
        var width = right - left; //横幅の計算
        var height = top - bottom; //縦幅の計算
        //アートボード縦横サイズの計測ここから

        //数値の変換計算ここから
        var mp = 2.83466;
        var mp3 = mp * 3;
        var mp12 = mp * 12;
        //数値の変換計算ここまで

        //オフセットガイド作成ここから
        if(checkBox1.value === true){ //オフセットにチェックがある場合
            var offSetText = eval(offSet.text);//テキストを数値に変換
            var n = point(offSetText);//関数（小数点第３位まで計算）
            try{
                var activeName1 = docObj.layers[layerName1.text];//レイヤーの指定
                activeName1.locked = false;//レイヤーのロック解除
                docObj.activeLayer = activeName1;//レイヤーをアクティブにする
            }catch(e){};//エラーを無視する

            //四角形ガイドの作成ここから
            var rectObj = docObj.activeLayer.pathItems.rectangle(top - n,left + n,width - os(n),height - os(n));//四角形の作成
            rectObj.guides = true;//ガイドに変換
            //四角形ガイドの作成ここまで

            activeName1.locked = true;//レイヤーをロック
        };
        //オフセットガイド作成ここまで

        //トリムマーク作成ここから
        if(checkbox2.value === true){
            try{
                var activeName2 = docObj.layers[layerName2.text];  //トリムマークレイヤーの指定
                activeName2.locked = false; //トリムマークレイヤーのロック解除
                docObj.activeLayer = activeName2; //トリムマークレイヤーをアクティブ化
            }catch(e){};

            //トリムマークの描画　ここから
            //左上　ここから
            var trimLine1 = docObj.activeLayer.pathItems.add(); //パス作成
            trimLine1.setEntirePath([[left - mp12,top],[left - mp3,top],[left - mp3,top + mp12]]);//パス座標
            trimLine1.filled = false;//塗りなし
            trimLine1.strokeWidth = point(0.1);//線幅
            trimLine1.strokeColor = setCMYK(0,0,0,100);//線色
            var trimLine2 = docObj.activeLayer.pathItems.add();//パス作成
            trimLine2.setEntirePath([[left - mp12,top + mp3],[left,top + mp3],[left,top + mp12]]);//パス座標
            trimLine2.filled = false;//塗りなし
            trimLine2.strokeWidth = point(0.1);//線幅
            trimLine2.strokeColor = setCMYK(0,0,0,100);//線色
            //左上　ここまで

            //右上　ここから
            var trimLine3 = docObj.activeLayer.pathItems.add();
            trimLine3.setEntirePath([[right + mp12,top],[right + mp3,top],[right + mp3,top + mp12]]);
            trimLine3.filled = false;
            trimLine3.strokeWidth = point(0.1);
            trimLine3.strokeColor = setCMYK(0,0,0,100);
            var trimLine4 = docObj.activeLayer.pathItems.add();
            trimLine4.setEntirePath([[right + mp12,top + mp3],[right,top + mp3],[right,top + mp12]]);
            trimLine4.filled = false;
            trimLine4.strokeWidth = point(0.1);
            trimLine4.strokeColor = setCMYK(0,0,0,100);
            //右上　ここまで

            //左下　ここから
            var trimLine5 = docObj.activeLayer.pathItems.add();
            trimLine5.setEntirePath([[left - mp12,bottom],[left - mp3,bottom,],[left - mp3,bottom - mp12]]);
            trimLine5.filled = false;
            trimLine5.strokeWidth = point(0.1);
            trimLine5.strokeColor = setCMYK(0,0,0,100);
            var trimLine6 = docObj.activeLayer.pathItems.add();
            trimLine6.setEntirePath([[left - mp12,bottom - mp3],[left,bottom - mp3],[left,bottom - mp12]]);
            trimLine6.filled = false;
            trimLine6.strokeWidth = point(0.1);
            trimLine6.strokeColor = setCMYK(0,0,0,100);
            //左下　ここまで

                        
            //右下　ここから
            var trimLine7 = docObj.activeLayer.pathItems.add();
            trimLine7.setEntirePath([[right + mp12,bottom],[right + mp3,bottom],[right + mp3,bottom - mp12]]);
            trimLine7.filled = false;
            trimLine7.strokeWidth = point(0.1);
            trimLine7.strokeColor = setCMYK(0,0,0,100);
            var trimLine8 = docObj.activeLayer.pathItems.add();
            trimLine8.setEntirePath([[right + mp12,bottom - mp3],[right,bottom - mp3],[right,bottom - mp12]]);
            trimLine8.filled = false;
            trimLine8.strokeWidth = point(0.1);
            trimLine8.strokeColor = setCMYK(0,0,0,100);
            //右下　ここまで
            //トリムマークの描画　ここまで

            activeName2.locked = true;//レイヤーロック
        };//トリムマーク作成ここまで
    };//for    
}//OKボタンの処理ここまで
dialog.center();//中央表示
dialog.show();//ダイアログ表示

//Ptとmmの変換　ここから
function point(num){
    var mp = 2.383466;
    var offMp = num * mp;
    return Math.round(offMp * 100) / 100;
}
//Ptとmmの変換　ここまで

//数値を２倍にする計算　ここから
function os(size){
    return size * 2;
}
//数値を２倍にする計算　ここまで

//CMYK　ここから
function setCMYK(c,m,y,k){
    var CMYK = new CMYKColor();
    CMYK.cyan = c;
    CMYK.magenta = m;
    CMYK.yellow = y;
    CMYK.black = k;
    return CMYK;
}
//CMYK　ここまで